Index: usr.bin/xlint/lint1/mem.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/mem.c,v
retrieving revision 1.3
diff -u -r1.3 mem.c
--- usr.bin/xlint/lint1/mem.c	7 Jul 2004 12:13:26 -0000	1.3
+++ usr.bin/xlint/lint1/mem.c	25 Dec 2006 10:15:49 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: mem.c,v 1.4 2006/03/08 07:18:51 moritz Exp $	*/
 /*	$NetBSD: mem.c,v 1.2 1995/07/03 21:24:24 cgd Exp $	*/
 
 /*
@@ -45,7 +46,7 @@
 	void	*p;
 
 	if ((p = malloc(s)) == NULL)
-		nomem();
+		err(1, NULL);
 	return (p);
 }
 
@@ -55,7 +56,7 @@
 	void	*p;
 
 	if ((p = calloc(n, s)) == NULL)
-		nomem();
+		err(1, NULL);
 	return (p);
 }
 
@@ -63,7 +64,7 @@
 xrealloc(void *p, size_t s)
 {
 	if ((p = realloc(p, s)) == NULL)
-		nomem();
+		err(1, NULL);
 	return (p);
 }
 
@@ -73,12 +74,6 @@
 	char	*s2;
 
 	if ((s2 = strdup(s)) == NULL)
-		nomem();
+		err(1, NULL);
 	return (s2);
 }
-
-void
-nomem(void)
-{
-	errx(1, "virtual memory exhausted");
-}
Index: usr.bin/xlint/lint1/mem1.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/mem1.c,v
retrieving revision 1.7
diff -u -r1.7 mem1.c
--- usr.bin/xlint/lint1/mem1.c	3 Aug 2006 16:40:48 -0000	1.7
+++ usr.bin/xlint/lint1/mem1.c	25 Dec 2006 10:17:08 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: mem1.c,v 1.10 2006/03/08 07:18:51 moritz Exp $	*/
 /*	$NetBSD: mem1.c,v 1.2 1995/07/03 21:24:25 cgd Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: mem1.c,v 1.2 1995/07/03 21:24:25 cgd Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/mem1.c,v 1.7 2006/08/03 16:40:48 swildner Exp $
  */
 
@@ -164,22 +164,10 @@
 xnewblk(void)
 {
 	mbl_t	*mb;
-	int	prot, flags;
 
 	mb = xmalloc(sizeof (mbl_t));
-
-	/* use mmap instead of malloc to avoid malloc's size overhead */
-
-	prot = PROT_READ | PROT_WRITE;
-	flags = MAP_ANON | MAP_PRIVATE;
-	mb->blk = mmap(NULL, mblklen, prot, flags, -1, (off_t)0);
-	if (mb->blk == (void *)MAP_FAILED)
-		err(1, "can't map memory");
-	if (ALIGN((u_long)mb->blk) != (u_long)mb->blk)
-		errx(1, "mapped address is not aligned");
-
+	mb->blk = xmalloc(mblklen);
 	mb->size = mblklen;
-
 	return (mb);
 }
 
@@ -302,7 +290,7 @@
 }
 
 /*
- * Free all memory which is allocated by the the current expression.
+ * Free all memory which is allocated by the current expression.
  */
 void
 tfreeblk(void)
Index: usr.bin/xlint/lint1/op.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/op.h,v
retrieving revision 1.1
diff -u -r1.1 op.h
--- usr.bin/xlint/lint1/op.h	17 Jun 2003 02:56:38 -0000	1.1
+++ usr.bin/xlint/lint1/op.h	25 Dec 2006 10:17:56 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: op.h,v 1.3 2005/11/29 20:09:57 cloder Exp $	*/
 /*	$NetBSD: op.h,v 1.2 1995/07/03 21:24:27 cgd Exp $	*/
 
 /*
@@ -29,6 +30,8 @@
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $DragonFly$
  */
 
 /*
@@ -48,7 +51,7 @@
 	u_int	m_tlansiu : 1;	/* warning if left op. is unsign. in ANSI C */
 	u_int	m_transiu : 1;	/* warning if right op. is unsign. in ANSI C */
 	u_int	m_tpconf : 1;	/* test possible precedence confusion */
-	u_int	m_comp : 1;	/* op. performs comparision */
+	u_int	m_comp : 1;	/* op. performs comparison */
 	u_int	m_enumop : 1;	/* valid operation on enums */
 	u_int	m_badeop : 1;	/* dubious operation on enums */
 	u_int	m_eqwarn : 1;	/* warning if on operand stems from == */
Index: usr.bin/xlint/lint1/param.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/param.h,v
retrieving revision 1.4
diff -u -r1.4 param.h
--- usr.bin/xlint/lint1/param.h	25 Aug 2006 22:37:09 -0000	1.4
+++ usr.bin/xlint/lint1/param.h	25 Dec 2006 10:18:53 -0000
@@ -1,4 +1,5 @@
-/*	$NetBSD: param.h,v 1.4 1995/07/23 18:14:41 ragge Exp $	*/
+/*	$OpenBSD: param.h,v 1.14 2006/04/03 13:55:02 espie Exp $	*/
+/*	$NetBSD: param.h,v 1.6 1996/04/01 21:47:57 mark Exp $	*/
 
 /*
  * Copyright (c) 1994, 1995 Jochen Pohl
@@ -63,32 +64,13 @@
  * Should be set to 1 if the difference of two pointers is of type long
  * or the value of sizeof is of type unsigned long.
  */
-#ifdef __amd64__
 #define PTRDIFF_IS_LONG		1
 #define SIZEOF_IS_ULONG		1
-#elif __i386__
-#define PTRDIFF_IS_LONG		0
-#define SIZEOF_IS_ULONG		0
-#elif __m68k__
-#define PTRDIFF_IS_LONG		0
-#define SIZEOF_IS_ULONG		0
-#elif __ns32k__
-#define PTRDIFF_IS_LONG		0
-#define SIZEOF_IS_ULONG		0
-#elif __sparc__
-#define PTRDIFF_IS_LONG		0
-#define SIZEOF_IS_ULONG		0
-#elif __vax__
-#define PTRDIFF_IS_LONG         0
-#define SIZEOF_IS_ULONG         0
-#else
-#error unknown machine type
-#endif
 
 /*
  * Make sure this matches wchar_t.
  */
-#define WCHAR	SHORT
+#define WCHAR	INT
 
 #ifndef __GNUC__
 #ifndef lint
@@ -101,14 +83,9 @@
 typedef	u_long	u_quad_t;
 #endif
 #endif
-
-
-/*
- * long double only in ANSI C.
- */
 typedef	long double ldbl_t;
 
 /*
- * Some traditional compilers are not able to assign structures.
+ * Modern compilers are able to assign structures.
  */
 #define STRUCT_ASSIGN(dest, src)	(dest) = (src)
Index: usr.bin/xlint/lint1/scan.l
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/scan.l,v
retrieving revision 1.8
diff -u -r1.8 scan.l
--- usr.bin/xlint/lint1/scan.l	17 Jan 2006 23:49:13 -0000	1.8
+++ usr.bin/xlint/lint1/scan.l	25 Dec 2006 10:22:11 -0000
@@ -1,4 +1,5 @@
 %{
+/*	$OpenBSD: scan.l,v 1.30 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: scan.l,v 1.8 1995/10/23 13:38:51 jpo Exp $	*/
 
 /*
@@ -31,7 +32,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: scan.l,v 1.8 1995/10/23 13:38:51 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/scan.l,v 1.8 2006/01/17 23:49:13 dillon Exp $
  */
 
@@ -69,12 +69,14 @@
 static	int	keyw(sym_t *);
 static	int	icon(int);
 static	int	fcon(void);
+static  int	fhexcon(void);
 static	int	operator(int, op_t);
 static	int	ccon(void);
 static	int	wccon(void);
 static	int	getescc(int);
 static	void	directive(void);
 static	void	comment(void);
+static	void	slashslashcomment(void);
 static	int	string(void);
 static	int	wcstrg(void);
 
@@ -86,16 +88,20 @@
 OD	[0-7]
 HD	[0-9A-Fa-f]
 EX	([eE][+-]?[0-9]+)
+HEX	([pP][+-]?[0-9]+)
 
 %%
 
-{L}({L}|{D})*		 	return (name());
+{L}({L}|{D})*			return (name());
 0{OD}*[lLuU]*			return (icon(8));
 {NZD}{D}*[lLuU]*		return (icon(10));
 0[xX]{HD}+[lLuU]*		return (icon(16));
 {D}+\.{D}*{EX}?[fFlL]?		|
 {D}+{EX}[fFlL]?			|
 \.{D}+{EX}?[fFlL]?		return (fcon());
+0[xX]{HD}+\.{HD}*{HEX}[fFlL]?	|
+0[xX]{HD}+{HEX}[fFlL]?		|
+0[xX]\.{HD}+{HEX}[fFlL]?	return (fhexcon());
 "="				return (operator(T_ASSIGN, ASSIGN));
 "*="				return (operator(T_OPASS, MULASS));
 "/="				return (operator(T_OPASS, DIVASS));
@@ -150,12 +156,13 @@
 \n				incline();
 \t|" "|\f|\v			;
 "/*"				comment();
+"//"				slashslashcomment();
 .				badchar(yytext[0]);
 
 %%
 
 static void
-incline()
+incline(void)
 {
 	curr_pos.p_line++;
 	if (curr_pos.p_file == csrc_pos.p_file)
@@ -163,8 +170,7 @@
 }
 
 static void
-badchar(c)
-	int	c;
+badchar(int c)
 {
 	/* unknown character \%o */
 	error(250, c);
@@ -177,59 +183,69 @@
 static	struct	kwtab {
 	const	char *kw_name;	/* keyword */
 	int	kw_token;	/* token returned by yylex() */
-	scl_t	kw_scl;		/* storage class if kw_token T_SCLASS */
-	tspec_t	kw_tspec;	/* type spec. if kw_token T_TYPE or T_SOU */
-	tqual_t	kw_tqual;	/* type qual. fi kw_token T_QUAL */
+	union {
+		scl_t	kw_scl;		/* storage class if kw_token T_SCLASS */
+		tspec_t	kw_tspec;	/* type spec. if kw_token T_TYPE or T_SOU */
+		tqual_t	kw_tqual;	/* type qual. if kw_token T_QUAL */
+	} kw_u;
 	u_int	kw_stdc : 1;	/* STDC keyword */
 	u_int	kw_gcc : 1;	/* GCC keyword */
 } kwtab[] = {
-	{ "asm",	T_ASM,		0,	0,	0,	  0, 1 },
-	{ "__asm",	T_ASM,		0,	0,	0,	  0, 0 },
-	{ "__asm__",	T_ASM,		0,	0,	0,	  0, 0 },
-	{ "auto",	T_SCLASS,	AUTO,	0,	0,	  0, 0 },
-	{ "break",	T_BREAK,	0,	0,	0,	  0, 0 },
-	{ "case",	T_CASE,		0,	0,	0,	  0, 0 },
-	{ "char",	T_TYPE,		0,	CHAR,	0,	  0, 0 },
-	{ "const",	T_QUAL,		0,	0,	CONST,	  1, 0 },
-	{ "__const__",	T_QUAL,		0,	0,	CONST,	  0, 0 },
-	{ "__const",	T_QUAL,		0,	0,	CONST,	  0, 0 },
-	{ "continue",	T_CONTINUE,	0,	0,	0,	  0, 0 },
-	{ "default",	T_DEFAULT,	0,	0,	0,	  0, 0 },
-	{ "do",		T_DO,		0,	0,	0,	  0, 0 },
-	{ "double",	T_TYPE,		0,	DOUBLE,	0,	  0, 0 },
-	{ "else",	T_ELSE,		0,	0,	0,	  0, 0 },
-	{ "enum",	T_ENUM,		0,	0,	0,	  0, 0 },
-	{ "extern",	T_SCLASS,	EXTERN,	0,	0,	  0, 0 },
-	{ "float",	T_TYPE,		0,	FLOAT,	0,	  0, 0 },
-	{ "for",	T_FOR,		0,	0,	0,	  0, 0 },
-	{ "goto",	T_GOTO,		0,	0,	0,	  0, 0 },
-	{ "if",		T_IF,		0,	0,	0,	  0, 0 },
-	{ "inline",	T_SCLASS,	INLINE,	0,	0,	  0, 1 },
-	{ "__inline__",	T_SCLASS,	INLINE,	0,	0,	  0, 0 },
-	{ "__inline",	T_SCLASS,	INLINE,	0,	0,	  0, 0 },
-	{ "int",	T_TYPE,		0,	INT,	0,	  0, 0 },
-	{ "long",	T_TYPE,		0,	LONG,	0,	  0, 0 },
-	{ "register",	T_SCLASS,	REG,	0,	0,	  0, 0 },
-	{ "return",	T_RETURN,	0,	0,	0,	  0, 0 },
-	{ "short",	T_TYPE,		0,	SHORT,	0,	  0, 0 },
-	{ "signed",	T_TYPE,		0,	SIGNED,	0,	  1, 0 },
-	{ "__signed__",	T_TYPE,		0,	SIGNED,	0,	  0, 0 },
-	{ "__signed",	T_TYPE,		0,	SIGNED,	0,	  0, 0 },
-	{ "sizeof",	T_SIZEOF,	0,	0,	0,	  0, 0 },
-	{ "static",	T_SCLASS,	STATIC,	0,	0,	  0, 0 },
-	{ "struct",	T_SOU,		0,	STRUCT,	0,	  0, 0 },
-	{ "switch",	T_SWITCH,	0,	0,	0,	  0, 0 },
-	{ "typedef",	T_SCLASS,	TYPEDEF, 0,	0,	  0, 0 },
-	{ "union",	T_SOU,		0,	UNION,	0,	  0, 0 },
-	{ "unsigned",	T_TYPE,		0,	UNSIGN,	0,	  0, 0 },
-	{ "void",	T_TYPE,		0,	VOID,	0,	  0, 0 },
-	{ "volatile",	T_QUAL,		0,	0,	VOLATILE, 1, 0 },
-	{ "__volatile__", T_QUAL,	0,	0,	VOLATILE, 0, 0 },
-	{ "__volatile",	T_QUAL,		0,	0,	VOLATILE, 0, 0 },
-	{ "while",	T_WHILE,	0,	0,	0,	  0, 0 },
-	{ NULL,		0,		0,	0,	0,	  0, 0 }
+	{ "asm",		T_ASM,		{ 0 },		0, 1 },
+	{ "__asm",		T_ASM,		{ 0 },		0, 0 },
+	{ "__asm__",		T_ASM,		{ 0 },		0, 0 },
+	{ "__attribute__",	T_ATTRIBUTE,	{ 0 },		0, 0 },
+	{ "auto",		T_SCLASS,	{ AUTO },	0, 0 },
+	{ "break",		T_BREAK,	{ 0 },		0, 0 },
+	{ "case",		T_CASE,		{ 0 },		0, 0 },
+	{ "char",		T_TYPE,		{ CHAR },	0, 0 },
+	{ "const",		T_QUAL,		{ CONST },	1, 0 },
+	{ "__const__",		T_QUAL,		{ CONST },	0, 0 },
+	{ "__const",		T_QUAL,		{ CONST },	0, 0 },
+	{ "continue",		T_CONTINUE,	{ 0 },		0, 0 },
+	{ "default",		T_DEFAULT,	{ 0 },		0, 0 },
+	{ "do",			T_DO,		{ 0 },		0, 0 },
+	{ "double",		T_TYPE,		{ DOUBLE },	0, 0 },
+	{ "else",		T_ELSE,		{ 0 },		0, 0 },
+	{ "enum",		T_ENUM,		{ 0 },		0, 0 },
+	{ "extern",		T_SCLASS,	{ EXTERN },	0, 0 },
+	{ "float",		T_TYPE,		{ FLOAT },	0, 0 },
+	{ "for",		T_FOR,		{ 0 },		0, 0 },
+	{ "goto",		T_GOTO,		{ 0 },		0, 0 },
+	{ "if",			T_IF,		{ 0 },		0, 0 },
+	{ "inline",		T_SCLASS,	{ INLINE },	1, 0 },
+	{ "__inline__",		T_SCLASS,	{ INLINE },	0, 0 },
+	{ "__inline",		T_SCLASS,	{ INLINE },	0, 0 },
+	{ "int",		T_TYPE,		{ INT },	0, 0 },
+	{ "__lint_equal__",	T_LEQUAL,	{ 0 },		0, 0 },
+	{ "long",		T_TYPE,		{ LONG },	0, 0 },
+	{ "register",		T_SCLASS,	{ REG },	0, 0 },
+	{ "__restrict",		T_QUAL,		{ RESTRICT },	0, 0 },
+	{ "__restrict__",	T_QUAL,		{ RESTRICT },	0, 0 },
+	{ "return",		T_RETURN,	{ 0 },		0, 0 },
+	{ "short",		T_TYPE,		{ SHORT },	0, 0 },
+	{ "signed",		T_TYPE,		{ SIGNED },	1, 0 },
+	{ "__signed__",		T_TYPE,		{ SIGNED },	0, 0 },
+	{ "__signed",		T_TYPE,		{ SIGNED },	0, 0 },
+	{ "sizeof",		T_SIZEOF,	{ 0 },		0, 0 },
+	{ "static",		T_SCLASS,	{ STATIC },	0, 0 },
+	{ "struct",		T_SOU,		{ STRUCT },	0, 0 },
+	{ "switch",		T_SWITCH,	{ 0 },		0, 0 },
+	{ "typedef",		T_SCLASS,	{ TYPEDEF },	0, 0 },
+	{ "union",		T_SOU,		{ UNION },	0, 0 },
+	{ "unsigned",		T_TYPE,		{ UNSIGN },	0, 0 },
+	{ "void",		T_TYPE,		{ VOID },	0, 0 },
+	{ "volatile",		T_QUAL,		{ VOLATILE },	1, 0 },
+	{ "__volatile__",	T_QUAL,		{ VOLATILE },	0, 0 },
+	{ "__volatile",		T_QUAL,		{ VOLATILE },	0, 0 },
+	{ "while",		T_WHILE,	{ 0 },		0, 0 },
+	{ NULL,			0,		{ 0 },		0, 0 }
 };
 
+#define kw_scl		kw_u.kw_scl
+#define kw_tspec	kw_u.kw_tspec
+#define kw_tqual	kw_u.kw_tqual
+
 /* Symbol table */
 static	sym_t	*symtab[HSHSIZ1];
 
@@ -245,7 +261,7 @@
 /* free list for sbuf structures */
 static	sbuf_t	 *sbfrlst;
 
-/* Typ of next expected symbol */
+/* type of next expected symbol */
 symt_t	symtyp;
 
 
@@ -254,7 +270,7 @@
  * in a extra table for each name we found.
  */
 void
-initscan()
+initscan(void)
 {
 	struct	kwtab *kw;
 	sym_t	*sym;
@@ -262,8 +278,6 @@
 	u_quad_t uq;
 
 	for (kw = kwtab; kw->kw_name != NULL; kw++) {
-		if (kw->kw_stdc && tflag)
-			continue;
 		if (kw->kw_gcc && !gflag)
 			continue;
 		sym = getblk(sizeof (sym_t));
@@ -298,7 +312,7 @@
  * Get a free sbuf structure, if possible from the free list
  */
 static sbuf_t *
-allocsb()
+allocsb(void)
 {
 	sbuf_t	*sb;
 
@@ -307,7 +321,7 @@
 	} else {
 		sb = xmalloc(sizeof (sbuf_t));
 	}
-	(void)memset(sb, 0, sizeof (*sb));
+	(void)memset(sb, 0, sizeof (sbuf_t));
 	return (sb);
 }
 
@@ -315,8 +329,7 @@
  * Put a sbuf structure to the free list
  */
 static void
-freesb(sb)
-	sbuf_t	*sb;
+freesb(sbuf_t *sb)
 {
 	sb->sb_nxt = sbfrlst;
 	sbfrlst = sb;
@@ -327,7 +340,7 @@
  * Increment line count(s) if necessary.
  */
 static int
-inpc()
+inpc(void)
 {
 	int	c;
 
@@ -337,8 +350,7 @@
 }
 
 static int
-hash(s)
-	const	char *s;
+hash(const char *s)
 {
 	u_int	v;
 	const	u_char *us;
@@ -367,7 +379,7 @@
  * to the symbol table entry.
  */
 static int
-name()
+name(void)
 {
 	char	*s;
 	sbuf_t	*sb;
@@ -405,8 +417,7 @@
 }
 
 static sym_t *
-search(sb)
-	sbuf_t	*sb;
+search(sbuf_t *sb)
 {
 	sym_t	*sym;
 
@@ -421,8 +432,7 @@
 }
 
 static int
-keyw(sym)
-	sym_t	*sym;
+keyw(sym_t *sym)
 {
 	int	t;
 
@@ -441,8 +451,7 @@
  * The value is returned in yylval. icon() (and yylex()) returns T_CON.
  */
 static int
-icon(base)
-	int	base;
+icon(int base)
 {
 	int	l_suffix, u_suffix;
 	int	len;
@@ -486,10 +495,6 @@
 		if (u_suffix > 1)
 			u_suffix = 1;
 	}
-	if (tflag && u_suffix != 0) {
-		/* suffix U is illegal in traditional C */
-		warning(97);
-	}
 	typ = contypes[u_suffix][l_suffix];
 
 	errno = 0;
@@ -505,7 +510,7 @@
 		warning(252);
 
 	/*
-         * If the value is to big for the current type, we must choose
+         * If the value is too big for the current type, we must choose
 	 * another type.
 	 */
 	ansiu = 0;
@@ -521,9 +526,7 @@
 			typ = ULONG;
 		}
 		if (typ == UINT || typ == ULONG) {
-			if (tflag) {
-				typ = LONG;
-			} else if (!sflag) {
+			if (!sflag) {
 				/*
 				 * Remember that the constant is unsigned
 				 * only in ANSI C
@@ -537,22 +540,20 @@
 			typ = ULONG;
 		break;
 	case LONG:
-		if (ul > LONG_MAX && !tflag) {
+		if (ul > LONG_MAX) {
 			typ = ULONG;
 			if (!sflag)
 				ansiu = 1;
 		}
 		break;
 	case QUAD:
-		if (uq > QUAD_MAX && !tflag) {
+		if (uq > QUAD_MAX) {
 			typ = UQUAD;
 			if (!sflag)
 				ansiu = 1;
 		}
 		break;
 		/* LINTED (enumeration values not handled in switch) */
-	default:
-		break;
 	}
 
 	if (typ != QUAD && typ != UQUAD) {
@@ -579,10 +580,7 @@
  * to the width of type t.
  */
 int
-sign(q, t, len)
-	quad_t	q;
-	tspec_t	t;
-	int	len;
+sign(quad_t q, tspec_t t, int len)
 {
 	if (t == PTR || isutyp(t))
 		return (0);
@@ -590,10 +588,7 @@
 }
 
 int
-msb(q, t, len)
-	quad_t	q;
-	tspec_t	t;
-	int	len;
+msb(quad_t q, tspec_t t, int len)
 {
 	if (len <= 0)
 		len = size(t);
@@ -604,10 +599,7 @@
  * Extends the sign of q.
  */
 quad_t
-xsign(q, t, len)
-	quad_t	q;
-	tspec_t	t;
-	int	len;
+xsign(quad_t q, tspec_t t, int len)
 {
 	if (len <= 0)
 		len = size(t);
@@ -621,14 +613,14 @@
 }
 
 /*
- * Convert a string representing a floating point value into its interal
+ * Convert a string representing a floating point value into its integral
  * representation. Type and value are returned in yylval. fcon()
  * (and yylex()) returns T_CON.
  * XXX Currently it is not possible to convert constants of type
  * long double which are greater then DBL_MAX.
  */
 static int
-fcon()
+fcon(void)
 {
 	const	char *cp;
 	int	len;
@@ -650,11 +642,6 @@
 		typ = DOUBLE;
 	}
 
-	if (tflag && typ != DOUBLE) {
-		/* suffixes F and L are illegal in traditional C */
-		warning(98);
-	}
-
 	errno = 0;
 	d = strtod(cp, &eptr);
 	if (eptr != cp + len)
@@ -682,20 +669,65 @@
 	return (T_CON);
 }
 
+/*
+ * Convert an hexadecimal representation of a floating point value 
+ * into its integral representation. 
+ * Type and value are returned in yylval. fhexcon()
+ * (and yylex()) returns T_CON.
+ * XXX Currently no actual values are parsed.
+ */
 static int
-operator(t, o)
-	int	t;
-	op_t	o;
+fhexcon(void)
+{
+	const	char *cp;
+	int	len;
+	tspec_t typ;
+	char	c;
+	double	d;
+	float	f;
+
+	cp = yytext;
+	len = yyleng;
+
+	if ((c = cp[len - 1]) == 'f' || c == 'F') {
+		typ = FLOAT;
+		len--;
+	} else if (c == 'l' || c == 'L') {
+		typ = LDOUBLE;
+		len--;
+	} else {
+		typ = DOUBLE;
+	}
+
+	/* arbitrary value, until strtod can cope */
+	d = 1.0;
+
+	if (typ == FLOAT) {
+		f = (float)d;
+	}
+
+	(yylval.y_val = xcalloc(1, sizeof (val_t)))->v_tspec = typ;
+	if (typ == FLOAT) {
+		yylval.y_val->v_ldbl = f;
+	} else {
+		yylval.y_val->v_ldbl = d;
+	}
+
+	return (T_CON);
+}
+
+static int
+operator(int t, op_t o)
 {
 	yylval.y_op = o;
 	return (t);
 }
 
 /*
- * Called if lex found a leading \'.
+ * Called if lex found a leading '.
  */
 static int
-ccon()
+ccon(void)
 {
 	int	n, val, c;
 	char	cv;
@@ -728,6 +760,7 @@
 
 	yylval.y_val = xcalloc(1, sizeof (val_t));
 	yylval.y_val->v_tspec = INT;
+	yylval.y_val->v_lspec = CHAR;
 	yylval.y_val->v_quad = val;
 
 	return (T_CON);
@@ -737,7 +770,7 @@
  * Called if lex found a leading L\'
  */
 static int
-wccon()
+wccon(void)
 {
 	static	char buf[MB_LEN_MAX + 1];
 	int	i, c;
@@ -790,8 +823,7 @@
  * -2 if the EOF is reached, and the charachter otherwise.
  */
 static int
-getescc(d)
-	int	d;
+getescc(int d)
 {
 	static	int pbc = -1;
 	int	n, c, v;
@@ -814,23 +846,14 @@
 	case '\\':
 		switch (c = inpc()) {
 		case '"':
-			if (tflag && d == '\'')
-				/* \" inside character constant undef. ... */
-				warning(262);
 			return ('"');
 		case '\'':
 			return ('\'');
 		case '?':
-			if (tflag)
-				/* \? undefined in traditional C */
-				warning(263);
 			return ('?');
 		case '\\':
 			return ('\\');
 		case 'a':
-			if (tflag)
-				/* \a undefined in traditional C */
-				warning(81);
 			return ('\a');
 		case 'b':
 			return ('\b');
@@ -843,9 +866,6 @@
 		case 't':
 			return ('\t');
 		case 'v':
-			if (tflag)
-				/* \v undefined in traditional C */
-				warning(264);
 			return ('\v');
 		case '8': case '9':
 			/* bad octal digit %c */
@@ -858,10 +878,7 @@
 			do {
 				v = (v << 3) + (c - '0');
 				c = inpc();
-			} while (--n && isdigit(c) && (tflag || c <= '7'));
-			if (tflag && n > 0 && isdigit(c))
-				/* bad octal digit %c */
-				warning(77, c);
+			} while (--n && isdigit(c) && (c <= '7'));
 			pbc = c;
 			if (v > UCHAR_MAX) {
 				/* character escape does not fit in char. */
@@ -870,9 +887,6 @@
 			}
 			return (v);
 		case 'x':
-			if (tflag)
-				/* \x undefined in traditional C */
-				warning(82);
 			v = 0;
 			n = 0;
 			while ((c = inpc()) >= 0 && isxdigit(c)) {
@@ -920,7 +934,7 @@
  *	# lineno "filename"
  */
 static void
-directive()
+directive(void)
 {
 	const	char *cp, *fn;
 	char	c, *eptr;
@@ -992,7 +1006,7 @@
  * parsed and a function which handles this comment is called.
  */
 static void
-comment()
+comment(void)
 {
 	int	c, lc;
 	static struct {
@@ -1004,10 +1018,12 @@
 		{ "CONSTCOND",		0,	constcond	},
 		{ "CONSTANTCOND",	0,	constcond	},
 		{ "CONSTANTCONDITION",	0,	constcond	},
+		{ "NORETURN",		1,	noreturn	},
 		{ "FALLTHRU",		0,	fallthru	},
 		{ "FALLTHROUGH",	0,	fallthru	},
 		{ "LINTLIBRARY",	0,	lintlib		},
 		{ "LINTED",		0,	linted		},
+		{ "LINTUSED",		0,	lintused	},
 		{ "LONGLONG",		0,	longlong	},
 		{ "NOSTRICT",		0,	linted		},
 		{ "NOTREACHED",		0,	notreach	},
@@ -1090,6 +1106,17 @@
 }
 
 /*
+ * Handle // style comments, which are valid in C99.
+ */
+static void
+slashslashcomment(void)
+{
+	int c;
+
+	while ((c = inpc()) != EOF && c != '\n');
+}
+
+/*
  * Clear flags for lint comments LINTED, LONGLONG and CONSTCOND.
  * clrwflgs() is called after function definitions and global and
  * local declarations and definitions. It is also called between
@@ -1097,11 +1124,12 @@
  * (if, switch, for, while).
  */
 void
-clrwflgs()
+clrwflgs(void)
 {
 	nowarn = 0;
-	quadflg = 0;
+	quadflg = 1;
 	ccflg = 0;
+	usedflg = 0;
 }
 
 /*
@@ -1110,7 +1138,7 @@
  * by the parser are responsible for freeing this buffer.
  */
 static int
-string()
+string(void)
 {
 	u_char	*s;
 	int	c;
@@ -1141,7 +1169,7 @@
 }
 
 static int
-wcstrg()
+wcstrg(void)
 {
 	char	*s;
 	int	c, i, n, wi;
@@ -1211,8 +1239,7 @@
  * XXX calls to getsym() should be delayed until decl1*() is called
  */
 sym_t *
-getsym(sb)
-	sbuf_t	*sb;
+getsym(sbuf_t *sb)
 {
 	dinfo_t	*di;
 	char	*s;
@@ -1283,8 +1310,7 @@
  * back to the symbol table.
  */
 void
-rmsym(sym)
-	sym_t	*sym;
+rmsym(sym_t *sym)
 {
 	if ((*sym->s_rlink = sym->s_link) != NULL)
 		sym->s_link->s_rlink = sym->s_rlink;
@@ -1297,8 +1323,7 @@
  * table.
  */
 void
-rmsyms(syms)
-	sym_t	*syms;
+rmsyms(sym_t *syms)
 {
 	sym_t	*sym;
 
@@ -1316,9 +1341,7 @@
  * Put a symbol into the symbol table
  */
 void
-inssym(bl, sym)
-	int	bl;
-	sym_t	*sym;
+inssym(int bl, sym_t *sym)
 {
 	int	h;
 
@@ -1338,7 +1361,7 @@
  * level 0.
  */
 void
-cleanup()
+cleanup(void)
 {
 	sym_t	*sym, *nsym;
 	int	i;
@@ -1361,8 +1384,7 @@
  * Create a new symbol with the name of an existing symbol.
  */
 sym_t *
-pushdown(sym)
-	sym_t	*sym;
+pushdown(sym_t *sym)
 {
 	int	h;
 	sym_t	*nsym;
@@ -1392,9 +1414,7 @@
  * The type of information in yylval is described by tok.
  */
 void
-freeyyv(sp, tok)
-	void	*sp;
-	int	tok;
+freeyyv(void *sp, int tok)
 {
 	if (tok == T_NAME || tok == T_TYPENAME) {
 		sbuf_t *sb = *(sbuf_t **)sp;
